<?php

namespace Drp\AdfsSocialiteProvider;

use Illuminate\Support\ServiceProvider as BaseServiceProvider;
use Laravel\Socialite\Contracts\Factory;

class ServiceProvider extends BaseServiceProvider
{
    /**
     * Bootstrap services.
     */
    public function boot(): void
    {
        $manager = $this->app[Factory::class];
        $manager->extend('adfs', function ($app) {
            return new AdfsProvider(
                $app['request'],
                config('turnstile.auth.client_id'),
                config('turnstile.auth.client_secret'),
                route('adfs.callback')
            );
        });
    }

    /**
     * Register services.
     */
    public function register(): void
    {
        $this->publishes([
            __DIR__.'/database/migrations/2018_04_04_213239_add_adfs_id_to_users_table.php' => database_path('migrations/2018_04_04_213239_add_adfs_id_to_users_table.php'),
            __DIR__.'/config/turnstile.php' => config_path('turnstile.php'),
        ]);
        $this->loadRoutesFrom(__DIR__.'/routes.php');
        $this->mergeConfigFrom(__DIR__.'/config/turnstile.php', 'turnstile');

        $this->app->bind('adfs.redirect', function () {
           return redirect()->to('/');
        });
    }
}
